from axipy import Table

from SmothingGeometry.ui.tool_smothing.tool_proc_smothing import smoth_geometry


class CacheTableUpdate:
    def __init__(self,tab:Table,size=1000):
        self.__tab=tab
        self.__size=size
        self.__cache=[]
    def add(self,ft):
        self.__cache.append(ft)
        if len(self.__cache)>self.__size:
            self.__tab.update(self.__cache)
            self.__cache.clear()
    def end(self):
        if len(self.__cache)>0:
            self.__tab.update(self.__cache)
            self.__cache.clear()
def smoth_geometry_tab(tab,func_smoth,coef):
    tab_cah=CacheTableUpdate(tab)
    for ft in tab.items():
        if ft.geometry is None:
            continue
        new_geo=smoth_geometry(ft.geometry,coef,func_smoth)
        if new_geo is None:
            continue
        ft.geometry=new_geo
        tab_cah.add(ft)
    tab_cah.end()

