from axipy import view_manager, Geometry, LineString, Feature, ListPoint, Polygon

from RasterGridTool.Test.Grid.Contour.tool_smothing.Chaikins_smoth import Object
from RasterGridTool.toolprocessing.ui.contour.tool_smothing.SmothCubic import scipySmoth


def listPntToTuple(list_point):
    list_uple_xy=[]
    for pnt in list_point:
        list_uple_xy.append((pnt.x,pnt.y))
    return list_uple_xy
def smothing_points(points:ListPoint,coef_count):
    pnts=listPntToTuple(points)
    count = len(points)
    isClose = False
    if points[0] == points[count - 1]:
        isClose = True
    obj_points = Object(pnts)
    new_points = obj_points.Smooth_by_Chaikin(3)
    if not isClose:
        new_points.insert(0, pnts[0])
        new_points.append(pnts[-1])
    return new_points

def smothing_obj(geo_object:Geometry)->Geometry:
    if isinstance(geo_object,LineString):
        #new_points=scipySmoth(listPntToTuple(geo_object.points),7,'quadratic')
        new_points=scipySmoth(listPntToTuple(geo_object.points),7,)
        new_geo=LineString(new_points,geo_object.coordsystem)
        return new_geo
    if isinstance(geo_object,Polygon):
        #new_points = smothing_points(geo_object.points,3)
        new_points = scipySmoth(listPntToTuple(geo_object.points), 7 )
        new_geo = Polygon(new_points, geo_object.coordsystem)
        return new_geo

map_view=view_manager.mapviews[0]
layers=map_view.map.layers
cosmetic_layer=map_view.map.cosmetic
tab_cosmetic=cosmetic_layer.data_object

tab_source=layers[0].data_object
for ft in tab_source.items():
    geo=smothing_obj(ft.geometry)
    if geo is not None:
        ft_cosmectis=Feature(geometry=geo)
        tab_cosmetic.insert(ft_cosmectis)
jkl=0