from axipy import Table


class CacheTableUpdate:
    def __init__(self,tab:Table,size=1000):
        self.__tab=tab
        self.__size=size
        self.__cache=[]
    def add(self,ft):
        self.__cache.append(ft)
        if len(self.__cache)>self.__size:
            self.__tab.update(self.__cache)
            self.__cache.clear()
    def end(self):
        if len(self.__cache)>0:
            self.__tab.update(self.__cache)
            self.__cache.clear()